/*	Copyright 1989 Brown University -- Steven P. Reiss		*/

/************************************************************************/
/*									*/
/*		animex.c						*/
/*									*/
/*	This is an example of the use of the animation facilities of	*/
/*	ASH.								*/
/*									*/
/*									*/
/************************************************************************/

#include <ash.h>




#define TRUE 1
#define FALSE 0
#define NULL 0
#define BALLS 10





main(argc,argv)
   int argc;
   char **argv;
{
   ASH_WINDOW a,b,c,d,e,f,g,h;
   int i,j,k,disp;
   int cma,cmb,cmc;
   int x[BALLS],y[BALLS],vx[BALLS],vy[BALLS];
   int lx,by,rx,ty;
   int col[BALLS];
   int x0[BALLS],y0[BALLS],x1[BALLS],y1[BALLS];

   argc = ASHset_application(argc,argv);

   a = ASHinq_top();

   ASHinq_size(a,ASH_SIZE_WINDOW,&lx,&by,&rx,&ty);
   b = a;
   c = ASHroot_X_window(a);
   a = ASHcreate(a,lx,by,lx,by,rx,ty,0,ASH_WINDOW_NOCLEAR|ASH_WINDOW_NOSAVE);

   for (i = 0; i < BALLS; ++i) {
      x[i] = (lx+rx)/2;
      y[i] = (ty+by)/2;
      vx[i] = random()%20-10;
      if (vx[i] == 0) vx[i] = 1;
      vy[i] = random()%20-10;
      if (vy[i] == 0) vy[i] = 1;
      x0[i] = x[i];
      y0[i] = y[i];
      col[i] = 1;
    };

   h = ASHanim_setup(a,8,2,FALSE);
   ASHanim_color(h,-1);
   ASHrectangle(h,lx,by,rx,ty);
   h = ASHanim_next_frame(a);
   ASHanim_color(h,-1);
   ASHrectangle(h,lx,by,rx,ty);

   for ( ; ; ) {
      for (i = 0; i < BALLS; ++i) {
	 x1[i] = x0[i];
	 y1[i] = y0[i];
	 x0[i] = x[i];
	 y0[i] = y[i];
	 x[i] += vx[i];
	 y[i] += vy[i];
	 if (x[i] < lx) {
	    x[i] = lx+lx-x[i];
	    vx[i] = random() % 10 + 1;
	    col[i] = (col[i]+1)%8;
	  };
	 if (x[i] > rx) {
	    x[i] = rx+rx-x[i];
	    vx[i] = -(random() % 10) - 1;
	    col[i] = (col[i]+1)%8;
	  };
	 if (y[i] < ty) {
	    y[i] = ty+ty-y[i];
	    vy[i] = random() % 10 + 1;
	    col[i] = (col[i]+1)%8;
	  };
	 if (y[i] > by) {
	    y[i] = by+by-y[i];
	    vy[i] = -(random() % 10) - 1;
	    col[i] = (col[i]+1)%8;
	  };
	 if (col[i] == 0) col[i] = 1;
	 ASHanim_color(h,-1);
	 ASHrectangle(h,x1[i]-5,y1[i]+5,x1[i]+5,y1[i]-5);
	 ASHanim_color(h,-col[i]-1);
	 ASHrectangle(h,x[i]-5,y[i]+5,x[i]+5,y[i]-5);
       };
      h = ASHanim_next_frame(a);
    };
};



